#include <windows.h>
#include <unistd.h>
#include <stdio.h>
#include <ctype.h>

#include "main.h"
#include "string_util.h"

enum {
    RAW=0,
    AMXX,
    MEMORY,
    MAX_FILES,
};

char g_filename[MAX_FILES][MAX_PATH];

int main(int argc, char **argv)
{
    console_print("***   AMXX UnCompress 1.0   ***\n");
    console_print("Web:     www.amxmodx-es.com\n");
    console_print("SteamID: Destro OnlyArg\n");
    console_print("===============================\n\n");

    char *filename;
    bool isamxx;
	int filename_len, c=optind;
	//c=0;
	if(c<argc) filename=argv[c];
	else {
        console_print("Arrastra un .amxx o .raw al .exe del programa\n");
        _exit
    }

    //filename = "C:\\Dev-Cpp\\amxx_uncompress\\prueba\\test_amxx_uncompress.raw";
	
	filename_len = strlen(filename);
	memset(g_filename, 0, MAX_FILES*MAX_PATH);
	
	if(strcmpi(filename+(filename_len-5), ".amxx") == 0)
    {
        strncpy(g_filename[AMXX], filename, MAX_PATH-1);
        
        strncpy(g_filename[RAW], filename, filename_len-5);
        strncat(g_filename[RAW], ".raw", MAX_PATH-1);
        
        strncpy(g_filename[MEMORY], filename, filename_len-5);
        strncat(g_filename[MEMORY], ".memory", MAX_PATH-1);
        
        isamxx = true;
    }
    else if(strcmpi(filename+(filename_len-4), ".raw") == 0)
    {
        strncpy(g_filename[RAW], filename, MAX_PATH-1);
        
        strncpy(g_filename[AMXX], filename, filename_len-4);
        strncat(g_filename[AMXX], ".amxx", MAX_PATH-1);
        
        strncpy(g_filename[MEMORY], filename, filename_len-4);
        strncat(g_filename[MEMORY], ".memory", MAX_PATH-1);
        
        isamxx = false;
    }
    else {
        console_print("Extencion invalida\n");
        _exit
    }

	FILE *fp=fopen(g_filename[isamxx], "rb");
	if(fp == NULL)
	{
        console_print("Error al abrir el archivo [%s]\n", g_filename[isamxx]);
        _exit
    }
    
    if(!read_header(fp))
	{
        fclose(fp);
        console_print("Formato invalido\n");
        _exit
    }
	
    int count;
    
    if(isamxx)
    {
        if(!amxx_uncompress(fp))
        {
            fclose(fp);
            console_print("Error al descomprimir\n");
            _exit
        }
        get_amxx_header();
        
        console_print("Buscando strings:\n");
        Sleep(700);
        
        count = generate_strings();
        console_print("Se encontraron %d strings\n\n", count);
        
        Sleep(500);
        
        console_print("\n* Descompresion completada!\n\n");
    }
    else {
        load_uncompress(fp);
        get_amxx_header();
        
        console_print("Cargando archivo .memory:\n");
        Sleep(700);
        if((count = load_memory_file()))
        {
            if(count==1) console_print("Se modifico una direccion de memoria\n\n");
            else console_print("Se modificaron %d direcciones de memoria\n\n", count);
        }
        else console_print("No hubo cambios en memoria\n\n");
        
        Sleep(500);
        
        if(!amxx_compress(fp))
        {
            fclose(fp);
            console_print("Error al comprimir\n");
            _exit
        }
        
        console_print("\n* Compresion completada!\n\n");
    }
    
    dump_header_data();
    fclose(fp);
    _exit
}

bool read_header(FILE *fp)
{
    memset(&(plugin),0x0,sizeof(plugin_t));
    
	read_dword(fp,&(plugin.magic));

	if(plugin.magic != 0x414d5858)
        return false;

    read_word(fp,&(plugin.version));
	read_byte(fp,&(plugin.sections));
	read_byte(fp,&(plugin.cellsize));
	read_dword(fp,&(plugin.disksize));
    read_dword(fp,&(plugin.imagesize));
	read_dword(fp,&(plugin.memsize));
	read_dword(fp,&(plugin.offs));
			
	plugin.headersize=ftell(fp);
	
	return true;
}

void write_header(FILE *fp)
{
    write_dword(fp,&(plugin.magic));
    write_word(fp,&(plugin.version));
	write_byte(fp,&(plugin.sections));
	write_byte(fp,&(plugin.cellsize));
	write_dword(fp,&(plugin.disksize));
    write_dword(fp,&(plugin.imagesize));
	write_dword(fp,&(plugin.memsize));
	write_dword(fp,&(plugin.offs));
}

void load_uncompress(FILE *fp)
{
    void *Uncompressed;
    size_t UncompressedSize;

    UncompressedSize = plugin.imagesize+1;
    Uncompressed = malloc(UncompressedSize);

    fseek(fp, plugin.headersize, SEEK_SET);
    fread(Uncompressed, UncompressedSize, 1, fp);

    plugin.data = Uncompressed;
}
    
bool amxx_uncompress(FILE *fp)
{
	void *Uncompressed;
	void *Compressed;
	size_t UncompressedSize;
	size_t CompressedSize;
	int Z_RES;
	
    CompressedSize = plugin.disksize+1;
	UncompressedSize = plugin.imagesize+1;

	Compressed=malloc(CompressedSize);
	Uncompressed=malloc(UncompressedSize);
		
    fseek(fp,plugin.offs, SEEK_SET);
    fread(Compressed, CompressedSize, 1, fp);

	if((Z_RES=uncompress((Bytef *)Uncompressed, (uLongf *)&UncompressedSize, (Bytef *)Compressed, CompressedSize)) != Z_OK)
	{
        console_print("ERROR: Z_RES = [%d]\n", Z_RES);
		return false;
    }

    int kEntries = 1;
	int kEntrySize = (sizeof(int32_t) * 4) + sizeof(int8_t);
	int baseaddr = sizeof(int32_t) + sizeof(int16_t) + sizeof(int8_t);
	baseaddr += kEntrySize * kEntries;

    plugin.sections = 1;
    plugin.offs = baseaddr;
    plugin.data = Uncompressed;
    plugin.imagesize = UncompressedSize;

	FILE * file;
    file = fopen(g_filename[RAW], "wb");
    if(file==NULL)
        return false;

    write_header(file);
    fwrite((char*)Uncompressed, UncompressedSize, 1, file);
    fclose(file);
    
    free(Compressed);

    return true;
}

bool amxx_compress(FILE *fp)
{
	void *Uncompressed;
	void *Compressed;
	size_t UncompressedSize;
	size_t CompressedSize;
	int Z_RES;
	
    CompressedSize = plugin.disksize+32; // Extra bytes for edit string :P
	UncompressedSize = plugin.imagesize+1;
		
	Compressed = malloc(CompressedSize);
	Uncompressed = plugin.data;

    if((Z_RES=compress((Bytef *)Compressed, (uLongf *)&CompressedSize, (const Bytef *)Uncompressed, UncompressedSize)) != Z_OK)
    {
        console_print("ERROR: Z_RES = [%d]\n", Z_RES);
		return false;
    }

    plugin.disksize = CompressedSize;
    
    FILE * file = fopen(g_filename[AMXX], "wb");
    if(file==NULL)
        return false;

    write_header(file);
    fwrite(Compressed, sizeof(char), CompressedSize, file);
    fclose(file);
    
    free(Compressed);
    free(Uncompressed);
    
    return true;
}

void dump_header_data()
{
    console_print("\nFileAMXX Header:\n");
	console_print("headersize      %d Bytes\n",(int)plugin.headersize);
	console_print("magic           0x%X\n",(int)plugin.magic);
	console_print("version         %d\n",(int)plugin.version);
	console_print("sections        %d\n",(int)plugin.sections);
	console_print("cellsize        %d Bytes\n",(int)plugin.cellsize);
	console_print("disksize        %d Bytes\n",(int)plugin.disksize);
	console_print("imagesize       %d Bytes\n",(int)plugin.imagesize);
	console_print("memsize         %d Bytes\n",(int)plugin.memsize);
	console_print("offs            0x%X\n\n",(int)plugin.offs);
	console_print("AMXX Header:\n");
	console_print("code size       %d Bytes\n", plugin.amx_header->dat - plugin.amx_header->cod);
	console_print("data size       %d Bytes\n", plugin.amx_header->hea - plugin.amx_header->dat);
	console_print("heap size       %d Bytes\n", plugin.amx_header->stp - plugin.amx_header->hea);
	console_print("publics         %d\n", (plugin.amx_header->natives - plugin.amx_header->publics) / plugin.amx_header->defsize);
	console_print("natives         %d\n", (plugin.amx_header->libraries - plugin.amx_header->natives) / plugin.amx_header->defsize);
	console_print("Frags:\n");
	if(plugin.amx_header->flags & 0x02) // symbolic info. available
        console_print("- AMX_FLAG_DEBUG");
    if(plugin.amx_header->flags & 0x04) // compact encoding
        console_print("- AMX_FLAG_COMPACT");
    if(plugin.amx_header->flags & 0x08) // opcode is a byte (not a cell)
        console_print("- AMX_FLAG_BYTEOPC");
    if(plugin.amx_header->flags & 0x10) // no array bounds checking; no STMT opcode
        console_print("- AMX_FLAG_NOCHECKS");
    if(plugin.amx_header->flags & 0x1000) // all native functions are registered
        console_print("- AMX_FLAG_NTVREG");
    if(plugin.amx_header->flags & 0x2000) // abstract machine is JIT compiled
        console_print("- AMX_FLAG_JITC");
    if(plugin.amx_header->flags & 0x4000) // busy browsing
        console_print("- AMX_FLAG_BROWSE");
    if(plugin.amx_header->flags & 0x8000) // jump/call addresses relocated
        console_print("- AMX_FLAG_RELOC");
    console_print("\n\n");
}

bool valid_char(cell value)
{
    if(value < 0 || value > 255)
        return false;
        
    if(!isalnum(value) && !isspace(value) && !ispunct(value) &&
    value != 1 && value != 2 && value != 3 && value != 4) // chat color :P
        return false;
        
    return true;
}

bool is_string(unsigned int addr)
{
	unsigned int *dat = (unsigned int *)addr;
    cell value;
    value = (cell)*dat;
	if(valid_char(value))
	{
        dat += 4;
        value = (cell)*dat;

		if(valid_char(value) || value == 0)
			return true;

		return false;
	}
	return false;
}

int GetAmxString(void *address, char *output, int size)
{
	cell *addr=(cell *)address;
	int count=size, len=0;
	
	while(count-- && *addr)
	{
		*output++=(char)*addr++;
		len++;
	}
	if(count) *output='\0';
	else {
		--output;
		*output='\0';
	}

	return len;
}

int SetAmxString(void *address, const char *input, bool forced)
{
	cell *addr=(cell *)address;
	const char *data = input;
	int writed=0;

	while((forced || *addr) && *data)
	{
		*addr++ = (cell)*data++;
		writed++;
	}
	*addr='\0';

    return writed;
}

int WriteAmxMemory(void *address, char *hex)
{
    cell *addr = (cell *)address;
    cell value;
    int len=0;
    
    while(*hex)
    {
        value = hex2long(hex, &hex);
        *addr++ = value;
        len++;
    }
    
    return len;
}

bool get_amxx_header()
{
    char *addr;
    addr = (char *)plugin.data;

	plugin.amx_header = (AMX_HEADER *)malloc(sizeof(AMX_HEADER));
	memcpy(plugin.amx_header, plugin.data, sizeof(AMX_HEADER));

	if(plugin.amx_header->magic != 0xf1e0)
        return false;

    return true;
}

int generate_strings()
{
    FILE *fp=fopen(g_filename[MEMORY], "wt");
    if(fp == NULL) return 0;
    
    char string_buff[2048], write_buff[2048];
    unsigned char *data;
	unsigned int base_addr, end_addr, current_addr, count;

    current_addr = base_addr = (unsigned int)((char *)plugin.data + plugin.amx_header->dat);
    end_addr = (unsigned int)(base_addr + (plugin.amx_header->hea - plugin.amx_header->dat));
    count = 0;
    
    while(current_addr < end_addr)
    {
        if(is_string(current_addr))
        {
            if(count < 15) Sleep(100);
            
            /*while(base_addr <= (current_addr-sizeof(cell)))
            {
                data = (unsigned char*)(current_addr - sizeof(cell));
                if(*data != 0) current_addr -= sizeof(cell);
                else break;
            }*/
            
	        GetAmxString((char*)current_addr, string_buff, charmax(string_buff));
	        string_to_format(string_buff, charmax(string_buff));
            
            console_print("- search string:[%s]\n", string_buff);
            
            formatex(write_buff, charmax(write_buff), ";data:0x%08X=\"%s\"\n", current_addr-base_addr, string_buff);
            fputs(write_buff, fp);
            
            current_addr += strlen(string_buff)*sizeof(cell);
            count++;
        }
        else current_addr += sizeof(cell);
    }
    
    fclose(fp);
    return count;
}

int load_memory_file()
{
    FILE *fp=fopen(g_filename[MEMORY], "rt");
    if(fp == NULL) return 0;
    
    char memory_buff[2048], read_buff[2048], *read_ptr;
	unsigned int data_base_addr, data_end_addr, code_base_addr, code_end_addr, offset_addr;
    int count, writed, section, memory_len;

    data_base_addr = (unsigned int)((char *)plugin.data + plugin.amx_header->dat);
    data_end_addr = (unsigned int)(data_base_addr + (plugin.amx_header->hea - plugin.amx_header->dat));
    
    code_base_addr = (unsigned int)((char *)plugin.data + plugin.amx_header->cod);
    code_end_addr = (unsigned int)(code_base_addr + (plugin.amx_header->dat - plugin.amx_header->cod));
    count = 0;

    while(!feof(fp))
    {
        memset(read_buff, 0, sizeof(read_buff));
        fgets(read_buff, charmax(read_buff), fp);
        trim(read_buff, read_buff, charmax(read_buff));
        
        if(!read_buff[0] || read_buff[0] == ';')
            continue;

        console_print("- ");
        
        if(strncmp(read_buff, "data:", 5) == 0) section = 1;
        else if(strncmp(read_buff, "code:", 5) == 0) section = 2;
        else {
            console_print("ERROR Memory File: bad parse [%s]\n", read_buff);
            continue;
        }
        
        strncpy(memory_buff, &read_buff[7], 8);memory_buff[8] = 0;
        offset_addr = hex2long(memory_buff, NULL);

        if(read_buff[16] != '"' && read_buff[16] != '[')
        {
            console_print("ERROR Memory File: bad parse [%s]\n", read_buff);
            continue;
        }

        strncpy(memory_buff, &read_buff[17], charmax(memory_buff));
        memory_len = strlen(memory_buff);
        
        if(count < 15) Sleep(100);
        
        if(section == 1)        // DATA
        {
            offset_addr += data_base_addr;
            if(offset_addr > data_end_addr)
            {
                console_print("ERROR: Bad Addr: 0x%08X\n", offset_addr-data_base_addr);
                continue;
            }
            
            if(read_buff[16] == '"') // String
            {
                bool forced=false;
                if(memory_buff[memory_len-1] == 'f')
                {
                    memory_len--;
                    forced = true;
                }
                if(memory_buff[memory_len-1] != '"')
                {
                    console_print("ERROR Memory File: bad parse [%s]\n", read_buff);
                    continue;
                }
                
                memory_buff[memory_len-1] = 0;
                string_to_raw(memory_buff, charmax(memory_buff));
        
                GetAmxString((char*)offset_addr, read_buff, charmax(read_buff));
                writed = SetAmxString((char*)offset_addr, memory_buff, forced);

                if(writed < strlen(memory_buff))
                {
                    console_print("WARNING:[Cout String]: \n -- ");
                    memory_buff[writed] = 0;
                }
                if(forced && writed > strlen(read_buff))
                    console_print("Forced ");
        
                string_to_format(memory_buff, charmax(memory_buff));
                string_to_format(read_buff, charmax(read_buff));
        
                console_print("Replace:[%s] for [%s] - len:[%d] - size:[%d bytes]\n", read_buff, memory_buff, writed, writed*sizeof(cell));
            }
            else {      // HEX

                if(memory_buff[memory_len-1] != ']')
                {
                    console_print("ERROR Memory File: bad parse [%s]\n", read_buff);
                    continue;
                }
                memory_buff[memory_len-1] = 0;
                
                writed = WriteAmxMemory((char*)offset_addr, memory_buff);
                
                console_print("WriteMemory: DATA addr:[0x%08X] - hex:[%s] - len:[%d] - size:[%d bytes]\n",
                offset_addr, memory_buff, writed, writed*sizeof(cell));
            }
        }
        else {      // CODE
            offset_addr += code_base_addr;
            if(offset_addr > code_end_addr)
            {
                console_print("ERROR: Bad Addr: 0x%08X\n", offset_addr-code_base_addr);
                continue;
            }

            if(read_buff[16] != '[' || memory_buff[memory_len-1] != ']') // HEX
            {
                console_print("ERROR Memory File: bad parse [%s]\n", read_buff);
                continue;
            }
            
            memory_buff[memory_len-1] = 0;

            writed = WriteAmxMemory((char*)offset_addr, memory_buff);

            console_print("WriteMemory: CODE addr:[0x%08X] - hex:[%s] - len:[%d] - size:[%d bytes]\n",
            offset_addr, memory_buff, writed, writed*sizeof(cell));
        }
        count++;
    }
    
    fclose(fp);
    
    return count;
}
